#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xresource.h>
#include <X11/cursorfont.h>

#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>
#include "tetX.h"
#include "keyjoy.h"
#include "egafont.h"

#ifndef HAVE_CONFIG_H
#include "scorefile.h"
#endif

/* X11 specific attributes */
#define CURSOR_TYPE XC_coffee_mug

Display		*display = NULL;
Visual  	*visual = NULL;
Window		window = None;
GC		graphContext = None;
Colormap	colmap = None;
Pixmap		screenContext = None;
Atom		WMProtocolsAtom, WMDeleteWndAtom, WMStateAtom; 
int		screenNumber;

int  FgrColour, BkgrColour, TxtColour, HiliteColour;

int  ConfineMode, Confined;
static  Cursor  ConfineCursor;

/* Common attributes */
int ScreenWidth, ScanWidth, ScreenHeight, ScreenDepth;
int VgaVideoMode, VideoChipset;

int ScrollAvailable = 1;
int TimerSuspended = 0;
int Intro = 1;
int BeepsEnabled, MusicEnabled;
int ResumeMode;
int LoopMode = 1, KillPlayMode = 0; 
int RedirInpMode = 1, RedirOutMode = 1, RedirErrMode = 0;
char *Player = NULL;
BOTTOM_MODE BottomMode;
WHERE_WE_ARE where;
char *PlayListFileName = NULL;
char *ScoresFileName = NULL;
char *BgColourName=NULL;
long   Ticks = 0;
char  FontFileName[81];
char  FontFileDir[81];
char  *DisplayName;
char *VarTexts[VAR_TEXTS];
char  *PositionText = NULL;


extern unsigned int Score;             // tetgame.c
extern int  Demo;                      // tetgame.c
extern int  JoyEnabled;                // tetgame.c
extern int  DefLevel, DefLays;         // tetgame.c

extern int  JoyEquiv[4];               // tetgame.c
#ifdef JOYSTICK_SUPPORTED
extern short UseJoystick;              // tetkeyjoy.c
extern int   JoyButtonMask;	       // tetkeyjoy.c	
#endif

void  ProceedExposeEvent(XExposeEvent *evnt); 

static char   *FontData = NULL;
static char   *ParmMask;
static struct itimerval gameitvalue, olditvalue;
static short   TimerSet = 0;
static char    *Modes;
//=====================================================================

void SetDefaultValues(void)
{
   BottomMode = B_NONE;
   BkgrColour = 0;
   Modes = DEFAULT_MODES;

   PlayListFileName = GetFullFileName(BGLIST_FILE_NAME);
   ScoresFileName = GetFullFileName(SCORES_FILE_NAME);
   BgColourName = strdup (DEFAULT_BG_RGB);

   if (egaFontType() == FONT_TYPE_X11_NATURAL)
   {   strcpy(FontFileName, DEFAULT_X_FONT);
       strcpy(FontFileDir, "");
   }       
   else
   {  
      strcpy(FontFileName, DEFAULT_FONT);
      strcpy(FontFileDir, CONSOLE_FONT_DIR);
   }      

#ifdef SCROLLER_DISABLED
    ScrollAvailable = 0;
#else
    ScrollAvailable = 1;
#endif


#ifdef JOYSTICK_SUPPORTED
   JoyEnabled = JOY_ENABLED_DEFAULT;
   UseJoystick = 1;		/* Driver, new interface */
   JoyButtonMask = 0;		/* No auto-repeat by default */
#else
   JoyEnabled = 0;
#endif

   DefLevel  = 0;
   DefLays   = 0;

   JoyEquiv[0] = '5';
   JoyEquiv[1] = '0';
   JoyEquiv[2] = '\0';
   JoyEquiv[3] = '\0';

   Demo = 0;
   Intro = 1;
   
   VarTexts[ScoreTextPos] = strdup(SCORE_TEXT);
   VarTexts[LevelTextPos] = strdup(LEVEL_TEXT);
   VarTexts[LayersTextPos] = strdup(LAYERS_TEXT);
   VarTexts[BonusTextPos] = strdup(BONUS_TEXT);
   VarTexts[NextTextPos] = strdup(NEXT_TEXT);
   VarTexts[JoyTextPos] = strdup(JOYSTICK_TEXT);
   VarTexts[TotalTextPos] = strdup(TOTAL_TEXT);
   VarTexts[TopHeaderPos] = strdup(TOP_HEADER);

   ResumeMode = 2;    
   ConfineMode = 1;
   PositionText = NULL;
}  


//---------------------------------------------------------------------

static void InvolveResourceFile(const char *filename, XrmDatabase *database)
{
    char *fullname = GetFullFileName(filename);
    
    XrmCombineFileDatabase(fullname, database, True);
    
    free(fullname);
}

static Bool GetResourceValue(XrmDatabase database, const char *resname,
			     const char *resclass, char **resvalptr)
{
    char	*restype;
    XrmValue	xrmval;
    Bool	status;

    status = XrmGetResource(database, resname, resclass, &restype, &xrmval);
    
    if (status)
    {  int size = xrmval.size;
       char *resvalue = malloc(size+1);
       if (resvalue)
       {  strncpy(resvalue, xrmval.addr, size);
	  while(--size >= 0 && strchr("\r\n\t ",resvalue[size]));  
	  resvalue[++size] = '\0';
          if (*resvalptr) free(*resvalptr);
	  *resvalptr = resvalue;
       }
       else status = False;
       	  
    }	 
    
    return status;

}

static Bool UpdateResourceValue(XrmDatabase database, const char *resname,
			     const char *resclass, char *resvalue)
{
    char	*restype = NULL;
    XrmValue	xrmval;
    Bool	status;

    status = XrmGetResource(database, resname, resclass, &restype, &xrmval);
    
    if (status)
    { 
       strncpy(resvalue, xrmval.addr, xrmval.size);
       resvalue[xrmval.size] = '\0';
    }	 
    
    return status;

}

static Bool GetFileNameFromResource(XrmDatabase database, const char *resname,
			     const char *resclass, char **filename)
{
    char	*resval = NULL;
    Bool	status;


    status = GetResourceValue(database, resname, resclass, &resval);
    if (status)
    { 
       if (*filename) free(*filename);
       *filename = GetFullFileName(resval);
       free(resval);
    }	 
    
    return status;

}
    
static void ProceedResources(void)
{
    char *temp=NULL, c;
    
    XrmDatabase	database = NULL;    
    XrmInitialize();
   
    InvolveResourceFile("/usr/lib/X11/app-defaults/XITetris", &database);
    InvolveResourceFile("~/.Xdefaults", &database);
    InvolveResourceFile("~/.XITetris", &database);

    if (egaFontType() == FONT_TYPE_X11_NATURAL)
       UpdateResourceValue(database, "XITetris.font", "Font", FontFileName);
    else   
    {   UpdateResourceValue(database,
            "XITetris.consolefont.name", "Consolefont.Name", FontFileName);
	UpdateResourceValue(database,
	    "XITetris.consolefont.directory", "Consolefont.directory",  FontFileDir);
    }
    
    GetFileNameFromResource(database, "XITetris.playlist",     "Playlist",      &PlayListFileName);
    GetFileNameFromResource(database, "XITetris.scorelist",    "Scorelist",     &ScoresFileName);

    GetResourceValue(database, "XITetris.bgcolor",      "Bgcolor",       &BgColourName);
    GetResourceValue(database, "XITetris.bgcolour",     "Bgcolour",      &BgColourName);
    GetResourceValue(database, "XITetris.position",     "Position",      &PositionText);
    GetResourceValue(database, "XITetris.modes",        "Modes",         &Modes);
    GetResourceValue(database, "XITetris.text.score",   "Text.Score",    &VarTexts[ScoreTextPos]);
    GetResourceValue(database, "XITetris.text.level",   "Text.Level",    &VarTexts[LevelTextPos]);
    GetResourceValue(database, "XITetris.text.layers",  "Text.Layers",   &VarTexts[LayersTextPos]);
    GetResourceValue(database, "XITetris.text.bonus",   "Text.Bonus",    &VarTexts[BonusTextPos]);
    GetResourceValue(database, "XITetris.text.next",    "Text.Next",     &VarTexts[NextTextPos]);
    GetResourceValue(database, "XITetris.text.joystick","Text.Joystick", &VarTexts[JoyTextPos]);
    GetResourceValue(database, "XITetris.text.total",   "Text.Total",    &VarTexts[TotalTextPos]);
    GetResourceValue(database, "XITetris.text.topscore","Text.Topscore", &VarTexts[TopHeaderPos]);

#ifdef JOYSTICK_SUPPORTED
    if (GetResourceValue(database, "XITetris.joystick.version", "Joystick.Version", &temp))
    {  c = toupper(*temp);
       if (c == '0' || c == 'O') UseJoystick = 1;
       if (c == '2' || c == 'X') UseJoystick = 2;
    }   
#endif

    if (GetResourceValue(database, "XITetris.joystick.enabled", "Joystick.Enabled", &temp))
    {   c = toupper(*temp);
        JoyEnabled = (c == '1' || c == 'Y');
    }   

    if (GetResourceValue(database, "XITetris.joystick.equivalents", "Joystick.Equivalents", &temp))
    {  int i;
       for (i=0; i<4; i++)
       {  c = temp[i];
          if (!c) break;
	  JoyEquiv[i] = c;
       }	   
    }   

  
    if (temp) free(temp);
     		       
    XrmDestroyDatabase(database);
}

//---------------------------------------------------------------------
/* Converts keywords to lower case */
static void ConvertToLC(int argc, char *argv[])
{  int i;
   char *arg, c;   

   for (i=1; i<argc; i++)
   {      
      arg = argv[i];
      
      if (*arg == '-')
      {
         while ((c = *++arg) != '\0') *arg = tolower(c);   
      }
   }
}   	 


static int FindArgument(int argc, char *argv[], const char *look_for, char *value)
{

   int i, len;
   char *arg;   


   len = strlen(look_for);
   value[0] = '\0';
       
   for (i=1; i<argc; i++)
   {  
      if (ParmMask[i]) continue;
      
      arg = argv[i];
      if (*arg++ != '-' || strncmp(arg, look_for, len))  continue;
      
      ParmMask[i] = '*';
                   
      if (i < argc-1)
      {  arg = argv[i+1];
         if (*arg != '-' || (strlen(arg)>0 && isdigit(*(arg+1))))
	                 strcpy(value, arg);  
      }	  
      
      break;
   }
   
   if ( i >= argc) i = 0;
   return i;
}      
   
   

static int ProceedArguments(int argc, char *argv[])
{
   char val[81], c;

   ParmMask = malloc(argc);
   if (!ParmMask) return 4;
    
   bzero (ParmMask, argc);   
   ConvertToLC(argc, argv);       

   if (FindArgument(argc, argv, "h", val) ||
        FindArgument(argc, argv, "?", val))
   {   ShowComHelp();
       return 4;
   }
  
   if (FindArgument(argc, argv, "disp", val) )
   {  if (strlen(val))
             DisplayName = strdup(val);
   }	     

   if (FindArgument(argc, argv, "kil", val))
    {  ResumeMode = 0; return 0; }
 
   if (FindArgument(argc, argv, "res", val))
    {  ResumeMode = 1; return 0; }
 
   if (FindArgument(argc, argv, "noc", val))
           ConfineMode = 0;
 
   if (FindArgument(argc, argv, "pos", val))
   {  if(PositionText) free(PositionText);
      PositionText = strdup(val);
   }      

   if (FindArgument(argc, argv, "i", val))
            Intro = 0;

#ifdef JOYSTICK_SUPPORTED
   if (FindArgument(argc, argv, "j", val))
   {   int i, k;
   
       JoyEnabled = 1;  
       for (i=k=0; i<4; i++) 
       {  c = val[i];
          if (c=='\0' || c=='_') break;
          c = toupper(c); 
          if (c == 'O') UseJoystick = 0;
	  else	      
          if (c == 'X') UseJoystick = 2;
	  else JoyEquiv[k++] = c;
       }
       if (i<4 && c == '_')
          JoyButtonMask = (int)strtol(val+i+1, NULL, 16);	
   }

   if (FindArgument(argc, argv, "k", val) ||
       FindArgument(argc, argv, "noj", val) )
            JoyEnabled = 0;
#endif

   if (FindArgument(argc, argv, "o", val) ||
       FindArgument(argc, argv, "modes", val) )
   {
        if (val)  Modes = val;
   }

   if (FindArgument(argc, argv, "la", val) ||
       FindArgument(argc, argv, "r", val) )
   {        c = val[0];
            if (isdigit(c)) DefLays = c - '0';
   }

   if (FindArgument(argc, argv, "l", val) )
   {        c = val[0];
            if (isdigit(c)) DefLevel = c - '0';
   }

   if (FindArgument(argc, argv, "d", val) )
		            Demo = 1;

   if (FindArgument(argc, argv, "m", val) )
   {    if (PlayListFileName) free(PlayListFileName);
        if (strlen(val) == 0) PlayListFileName = NULL;
        else PlayListFileName = GetFullFileName(val);
   }
/*
   if (FindArgument(argc, argv, "s", val) ||
          FindArgument(argc, argv, "nos", val)) 
            ScrollAvailable = 0;
*/
   if (FindArgument(argc, argv, "bg", val) ||
          FindArgument(argc, argv, "c", val) )
    {  if (BgColourName) free(BgColourName);
          BgColourName = strdup(val);
    }	  

   if (FindArgument(argc, argv, "f", val) ||
          FindArgument(argc, argv, "c", val) )
    {
        if (strlen(val))
	{  if (val[0] == '=') val[0] = '-'; 
	    strcpy(FontFileName, val);
        }	    
    }             

    free(ParmMask);
    return 0;
}


//=====================================================================

void IntervalHandler(int code)
{   
    
    signal(SIGALRM, IntervalHandler);
    Ticks++;

/*
    if (TimerSuspended)
    {
       if (TimerSuspended == 2) TimerSuspended = 1;
    }
    else
    {
 #ifndef SCROLLER_DISABLED
       if (where==W_PROLOGUE) // || (Demo && BottomMode == B_SCROLLER))
                                                 ScrollerTick();
 #endif
    }
*/
}

void SuspendTimer(void)
{
   TimerSuspended = 1;
   signal(SIGALRM, SIG_IGN);

//   if (TimerSuspended==1) return;
//   TimerSuspended = 2;
//   while (TimerSuspended == 2);
}

void ResumeTimer(void)
//{  TimerSuspended = 0; }
{
   struct itimerval tempitvalue;

   setitimer(ITIMER_REAL, &gameitvalue, &tempitvalue);
   signal(SIGALRM, IntervalHandler);
   TimerSuspended = 0;
}


static void DeleteTexts(void)
{  int i;

    for (i=0; i<VAR_TEXTS; i++) free(VarTexts[i]);
    if (PositionText) free(PositionText);
}    

static void TerminationProc(void)
{
     if (Confined) XUngrabPointer(display, CurrentTime);
         
     DeinitPlayLines();

     DeinitScroller();
     joyDeinit();

     if (TimerSet)	
        setitimer(ITIMER_REAL, &olditvalue, &olditvalue);
     signal (SIGALRM, SIG_DFL);
     TimerSet = 0;	

     if (FontData) egaFreeFont(FontData);
     DeinitRobImage();
     deinitPalette();
     terminate_video();

     if (DisplayName) free(DisplayName);


//     if (PlayListFileName) free(PlayListFileName);

     if (Player) free (Player);
     DeleteTexts();

}


void TerminationHandler(int code)
{
    TerminationProc();

    exit(8);
}

void ConfinePointer(void)
{
    Confined = (XGrabPointer(display, window, False, ButtonPressMask, 
               GrabModeAsync,
               GrabModeAsync,window,ConfineCursor,CurrentTime) == GrabSuccess);

//   if (Confined) XDefineCursor(display, window, ConfineCursor);
	    
}	    

void ReleasePointer(void)
{
   XUngrabPointer(display, CurrentTime);
   XDefineCursor(display, window, None);
   Confined = 0;
	    
}	    

int main(int argc, char *argv[])
{
   int (*move_proc)(void);
   char   message[121] = "";
/*   int ConfineNeeded; */
   int    rc;



   TimerSet = 0;	
   SetDefaultValues();
   ProceedResources();
   rc = ProceedArguments(argc, argv);
   if (rc) return rc;

   process_modes(Modes);

   if (ResumeMode < 2)
   {   rc=  ResumeGame(DisplayName, message, ResumeMode);
       goto Ret;
   }       
   
   rc = prepare_video(DisplayName);    
   if (rc) goto Ret;


    /*
     * Set confine mode for writable visuals
    */
   ConfineCursor = XCreateFontCursor(display, CURSOR_TYPE);	   
   /*
   if (ConfineMode)
   {   int vis_class = visual->class; 
       ConfineCursor = XCreateFontCursor(display, CURSOR_TYPE);	   
       ConfineNeeded = (  vis_class == PseudoColor
                    || vis_class == DirectColor
		    || vis_class == GrayScale);
   }
   else
      ConfineNeeded = 0;
  */  

/*   if (JoyEnabled) */
#ifdef JOYSTICK_SUPPORTED
   { if (joyInit() || joySetParams())
                    JoyEnabled = 0;
   }
#endif

   
   InitPlayLines();
   MusicEnabled = (PlayListFileName != NULL);

   FontData = egaLoadFont(FontFileName, FontFileDir, message);
   if (!FontData) goto Ret;
   egaSetFont(FontData);
  
   XMapRaised(display, window);
   XFlush(display);    
   XSync(display, screenNumber);    
   
   /*
   if (ConfineNeeded) ConfinePointer();	
   */
   InitRobImage();        
   InitBoard();
   InitScroller();

   // Getting player name

   Player = getenv("LOGNAME");
   if(!Player) Player  = getlogin(); 

   if (!Player)
       Player = "*** Unknown ***";
   else
   {   /* Try to get full nae */
       struct passwd   *p;
       p =  getpwnam(Player);
       if (p  && strlen(p->pw_gecos) > 0)
              Player = p->pw_gecos;
       
   }
   Player = strdup(Player);  /* So can use and
                                free it no matter how we got it */


   // Making tick equal to standard PC interval timer tick
   gameitvalue.it_interval.tv_sec = gameitvalue.it_value.tv_sec = 0l;
   gameitvalue.it_interval.tv_usec = gameitvalue.it_value.tv_usec = 10000000l / 182 ;

   setitimer(ITIMER_REAL, &gameitvalue, &olditvalue);
   TimerSet = 1;	
   signal(SIGALRM, IntervalHandler);
   signal(SIGTERM, TerminationHandler);
   TimerSuspended = 0;

            

   if (Intro)
   {  rc = ShowPrologue();
      if (rc == 8) goto Ret;
      if (rc == 4) Demo = 1;
   }

   InitIntergameScreen();

   if(Demo == 0)
   {
       Score = 0;
       rc = 4;
       if (ShowIntergameScreen()) goto Ret;

   }

   rc = 0;
/* Play game */

    while(rc>=0)
    {  NewGame();

       move_proc = Demo ? move_demo_figure : move_figure;
       while ((rc=(*move_proc)()) == 0 );
       if ( EndGame(rc-4) > 0) break;

     }  /* while(rc); */

     rc = 0;

Ret:
     TerminationProc();

     if (rc > 4 && strlen(message)>0) printf("xitetris error: %s\n", message);
     return rc;
}


int ProceedNonkeyEvent(XEvent *event)
{ 

//    XEvent event; 
   
    
//    while (XCheckTypedEvent(display, ClientMessage, &event))
//    if (ConfineMode && XCheckTypedEvent(display, ButtonPress, &event)) 
  switch(event->type)
  {	case Expose:
	  ProceedExposeEvent((XExposeEvent *)event);
	  break;
  
    case  ClientMessage:
      if ( (event->xclient.message_type == WMProtocolsAtom) &&
	       (event->xclient.data.l[0] == WMDeleteWndAtom) )
           {  TerminationHandler(8); return 1; }	    
	  break;
	  	        
	case ButtonPress:
	  if (ConfineMode)  
      {   if (Confined) ReleasePointer();
    	  else ConfinePointer();
	  }
	  break;

//	case VisibilityNotify:
//	  if (event->xvisibility.state == IconicState)
//			SuspendGame();
//	  break;			

  }	
	
  return 0;
}    		
